VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form Form1 
   Caption         =   "howto_curve_fit_weibull"
   ClientHeight    =   4005
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5715
   LinkTopic       =   "Form1"
   ScaleHeight     =   4005
   ScaleWidth      =   5715
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtD 
      Height          =   285
      Left            =   3720
      TabIndex        =   5
      Top             =   2400
      Width           =   1695
   End
   Begin RichTextLib.RichTextBox rchEquation 
      Height          =   615
      Left            =   3240
      TabIndex        =   15
      Top             =   120
      Width           =   2295
      _ExtentX        =   4048
      _ExtentY        =   1085
      _Version        =   393217
      BackColor       =   -2147483633
      BorderStyle     =   0
      Enabled         =   -1  'True
      Appearance      =   0
      TextRTF         =   $"Form1.frx":0000
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Arial"
         Size            =   14.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.PictureBox picGraph 
      Height          =   3015
      Left            =   120
      ScaleHeight     =   197
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   197
      TabIndex        =   9
      Top             =   120
      Width           =   3015
   End
   Begin VB.CommandButton cmdFindCurve 
      Caption         =   "Find Curve"
      Default         =   -1  'True
      Height          =   375
      Left            =   3240
      TabIndex        =   0
      Top             =   840
      Width           =   1095
   End
   Begin VB.CommandButton cmdClearPoints 
      Caption         =   "Clear Points"
      Height          =   375
      Left            =   4440
      TabIndex        =   1
      Top             =   840
      Width           =   1095
   End
   Begin VB.TextBox txtA 
      Height          =   285
      Left            =   3720
      TabIndex        =   2
      Top             =   1275
      Width           =   1695
   End
   Begin VB.TextBox txtB 
      Height          =   285
      Left            =   3720
      TabIndex        =   3
      Top             =   1635
      Width           =   1695
   End
   Begin VB.TextBox txtC 
      Height          =   285
      Left            =   3720
      TabIndex        =   4
      Top             =   1995
      Width           =   1695
   End
   Begin VB.TextBox txtError 
      Height          =   285
      Left            =   3720
      TabIndex        =   6
      Top             =   2760
      Width           =   1695
   End
   Begin VB.CommandButton cmdGraph 
      Cancel          =   -1  'True
      Caption         =   "Graph"
      Height          =   375
      Left            =   3960
      TabIndex        =   8
      Top             =   3480
      Width           =   1095
   End
   Begin VB.TextBox txtPercentError 
      Height          =   285
      Left            =   3720
      TabIndex        =   7
      Top             =   3120
      Width           =   1695
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "D:"
      Height          =   195
      Index           =   3
      Left            =   3360
      TabIndex        =   16
      Top             =   2445
      Width           =   165
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "A:"
      Height          =   195
      Index           =   0
      Left            =   3360
      TabIndex        =   14
      Top             =   1320
      Width           =   150
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "B:"
      Height          =   195
      Index           =   1
      Left            =   3360
      TabIndex        =   13
      Top             =   1680
      Width           =   150
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "C:"
      Height          =   195
      Index           =   2
      Left            =   3360
      TabIndex        =   12
      Top             =   2040
      Width           =   150
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Err:"
      Height          =   195
      Index           =   4
      Left            =   3360
      TabIndex        =   11
      Top             =   2805
      Width           =   240
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "%"
      Height          =   195
      Index           =   5
      Left            =   3360
      TabIndex        =   10
      Top             =   3165
      Width           =   120
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Drawing constants.
Private Const Xmin As Single = -0.1
Private Const Xmax As Single = 1#
Private Const Ymin As Single = -10#
Private Const Ymax As Single = 350#

Private HasSolution As Boolean
Private PtX As Collection
Private PtY As Collection
Private BestA As Double
Private BestB As Double
Private BestC As Double
Private BestD As Double

' Set up.
Private Sub Form_Load()
    HasSolution = False
    Set PtX = New Collection
    Set PtY = New Collection

    ' Set up the PictureBox for drawing.
    picGraph.ScaleLeft = Xmin
    picGraph.ScaleTop = Ymax
    picGraph.ScaleWidth = Xmax - Xmin
    picGraph.ScaleHeight = -(Ymax - Ymin)

    ' Pretty up the sample equation.
    rchEquation.SelStart = 9
    rchEquation.SelLength = 4
    rchEquation.SelCharOffset = 150
    rchEquation.SelStart = 13
    rchEquation.SelLength = 1
    rchEquation.SelCharOffset = 300
End Sub

' Save a new point.
Private Sub picGraph_MouseDown(Button As Integer, Shift As Integer, x As Single, Y As Single)
    ' Save the point.
    PtX.Add x
    PtY.Add Y
    picGraph.Refresh

    ' Debug.Print "(" & x & ", " & Y & ")"
End Sub

' Draw the points and best fit curve.
Private Sub picGraph_Paint()
Dim x_step As Double
Dim x As Double
Dim y0 As Double
Dim y1 As Double
Dim dx As Single
Dim dy As Single
Dim i As Integer

    ' Draw the axes.
    DrawAxes

    ' Draw the curve.
    If (HasSolution) Then
        x_step = picGraph.ScaleX(1, vbPixels, picGraph.ScaleMode)
        y0 = F(Xmin, BestA, BestB, BestC, BestD)
        For x = Xmin + x_step To Xmax Step x_step
            y1 = F(x, BestA, BestB, BestC, BestD)
            On Error Resume Next
            picGraph.Line (x - x_step, y0)-(x, y1), vbBlue
            On Error GoTo 0
            y0 = y1
        Next x
    End If

    ' Draw the points.
    dx = picGraph.ScaleWidth / 100
    dy = picGraph.ScaleHeight / 100
    picGraph.FillColor = vbWhite
    picGraph.FillStyle = vbFSSolid
    For i = 1 To PtX.Count
        picGraph.Line (PtX.Item(i) - dx, PtY.Item(i) - dy)-Step(2 * dx, 2 * dy), vbBlack, B
    Next i
End Sub

' Draw the axes.
Private Sub DrawAxes()
Const xthick As Single = 0.025
Const ythick As Single = 10#
Const xstep As Single = 0.25
Const ystep As Single = 20#
Dim x As Double
Dim Y As Double

    picGraph.Cls

    picGraph.Line (Xmin, 0)-(Xmax, 0)
    For x = xstep To Xmax Step xstep
        picGraph.Line (x, -ythick)-(x, ythick)
    Next x

    picGraph.Line (0, Ymin)-(0, Ymax)
    For Y = ystep To Ymax Step ystep
        picGraph.Line (-xthick, Y)-(xthick, Y)
    Next Y

    ' Label the axes.
    ' Y axis labels.
    For Y = 100 To Ymax Step 100
        picGraph.CurrentX = Xmin
        picGraph.CurrentY = Y - picGraph.TextHeight(Format$(Y)) / 2
        picGraph.Print Format$(Y)
    Next Y

    ' X axis labels.
    For x = xstep To Xmax Step xstep
        picGraph.CurrentX = x - picGraph.TextWidth(Format$(x)) / 2
        picGraph.CurrentY = 0 - picGraph.TextHeight(Format$(x)) + 10
        picGraph.Print Format$(x)
    Next x

End Sub

' Clear the points.
Private Sub cmdClearPoints_Click()
    HasSolution = False
    Set PtX = New Collection
    Set PtY = New Collection
    picGraph.Refresh

    txtA.Text = ""
    txtB.Text = ""
    txtC.Text = ""
    txtD.Text = ""
    txtError.Text = ""
    txtPercentError.Text = ""
End Sub

' Find parameters for a curve fit.
Private Sub cmdFindCurve_Click()
Dim start_time As Single
Dim stop_time As Single
Dim i As Integer
Dim error As Double

    Me.MousePointer = vbHourglass
    txtA.Text = ""
    txtB.Text = ""
    txtC.Text = ""
    txtD.Text = ""
    txtError.Text = ""
    txtPercentError.Text = ""
    DoEvents
    start_time = Timer

    ' Find a good fit.
    error = FindGoodFit(PtX, PtY, BestA, BestB, BestC, BestD, 5, 50)

    stop_time = Timer
    Debug.Print Format$(stop_time - start_time, "0.0000") & " seconds"

    txtA.Text = Format$(BestA)
    txtB.Text = Format$(BestB)
    txtC.Text = Format$(BestC)
    txtD.Text = Format$(BestD)

    ' Display the error.
    ShowError

    ' We have a solution.
    HasSolution = True
    picGraph.Refresh

    Me.MousePointer = vbDefault
End Sub

' Display the error.
Private Sub ShowError()
Dim error As Double
Dim total As Double
Dim pt As Integer

    ' Get the error.
    error = Sqr(ErrorSquared( _
        PtX, PtY, BestA, BestB, BestC, BestD))
    txtError.Text = Format$(error)

    ' Get the total of the function's values to
    ' calculate a percentage.
    total = 0
    For pt = 1 To PtX.Count
        total = total + F(PtX.Item(pt), BestA, BestB, BestC, BestD)
    Next pt
    total = error / total * 100
    txtPercentError.Text = Format$(total)
End Sub

' Regraph with the given parameters.
Private Sub cmdGraph_Click()
    ' Get the parameters.
    BestA = Val(txtA.Text)
    BestB = Val(txtB.Text)
    BestC = Val(txtC.Text)
    BestD = Val(txtD.Text)

    ShowError
    picGraph.Refresh
End Sub

